// Test polimorphic unions
// $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $

union <'a>list {
	void Nil;
	*['a, <'a>list] Cons;
}

int length(<'a>list l)
{
	switch l {
	case Nil[]:
		return 0;
	case Cons[hd, tl]:
		return 1 + length(tl);
	}
}

void iter(*(void ('a)) f, <'a>list l)
{
	switch l {
	case Nil[]:
		return;
		
	case Cons[hd, tl]:
		f(hd);
		iter(f, tl);
	}
}

<'b>list map(*('b ('a)) f, <'a>list l)
{
	switch l {
	case Nil[]:
		return Nil[];		

	case Cons[hd, tl]:
		return Cons[f(hd), map(f, tl)];
	}
}

string i2s(int i)
{
	switch i {
	case 10:
		return "ten";
	case 20:
		return "twenty";
	case x:
		return "hgw";
	}
}

section init
{
	<int>list i;
	<string>list s;
	
	i = Cons[1, Cons[10, Cons[20, Nil]]];
	s = Cons["foo", Cons["bar", Cons["baz", Nil[]]]];

	iter(print_int, i);
	print_string(".");
	iter(print_string, s);
	print_string(".");
	iter(print_string, map(i2s, i));
	print_string(".");
	
	print_int(length(i));
	print_string(".");
	print_int(length(s));
	print_string(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 11020.foobarbaz.hgwtentwenty.3.3.
 */
